.\" dummy line
.TH GNUPLOT 1 "28 January 1987"
.UC 4
.SH NAME
gnuplot \- an interactive plotting program
.SH SYNOPSIS
.B gnuplot
.br
.SH DESCRIPTION
.I Gnuplot 
is a command-driven interactive function plotting program.
Here are some of its features:
.PP
Plots any number of functions, built up of C operators, C library
functions, and some things C doesn't have like **, sgn(), etc.  Also
support for plotting data files, to compare actual
data to theoretical curves.
.PP
User-defined X and Y ranges (optional Y auto-ranging), smart Y scaling,
smart tic marks.
.PP
User-defined constants and functions.
.PP
Support through a generalized graphics driver for
AED 767,
BBN BitGraph,
HP2623,
HP75xx,
POSTSCRIPT,
QMS QUIC
ReGis (VT125 and VT2xx),
Selanar,
Tek 401x,
Vectrix 384,
and unixplot.  The PC version
supports IBM CGA & EGA, Hercules, ATT 6300,
and Corona 325 graphics.  Other devices can be added
simply, but will require recompiling.
.PP
Shell escapes and command line substitution.
.PP
Load and save capability.
.PP
Output redirection.
.PP
All computations performed in the complex domain.  Just the real part is
plotted by default, but functions like imag() and abs() and arg() are
available to override this.
.SH AUTHORS
Thomas Williams and Colin Kelley, Villanova University.
.br
(vu-vlsi!plot.UUCP)
.SH BUGS
The unixplot library does not provide for sending unixplot output to
a file.  As a result, unixplot output cannot be sent to a file with the
.I Gnuplot
\&'set output' command; instead, standard output must be redirected
to this file from the Unix command line.  For example:
.IP
\ \ \ \ \ \ \ 
.I % gnuplot > unixplot.out
.br
\ \ \ \ \ \ \ \ gnuplot>
.I set term unxiplot
.br
\ \ \ \ \ \ \ \ gnuplot>
.I plot sin(x)
.PP
The atan() function does not work correctly for complex arguments.
.SH SEE ALSO
See the printed manual or the on-line help for details on specific commands.
